#include "lpc23xx.h"
#include "plldrv.h"
/**
* Author: Steffen Graf
* Date: 15.11.09
* Version: 1.0
* Description: Inits PLL and connect it to CCLK
**/

void PLL_init(void){
    SCS |= (1<<5);			//Enable main OSC
    while(!(SCS&0x40));	//Wait until it's stable
    CLKSRCSEL = 0x1; 		//Select main OSC as clock source
	
	PLLCON = 0;				//Disable PLL
	PLLFEED = 0xAA;			//send 0xAA55 to apply changes
	PLLFEED = 0x55;
	
	PLLCFG = (1<<16)|23;	//Set PLL setting: div = 1 | mul = 24 | F_PLL = 288 MHz
	PLLFEED = 0xAA;
	PLLFEED = 0x55;
	
	PLLCON = 1;				//Enable PLL
	PLLFEED = 0xAA;
	PLLFEED = 0x55;
	
	while(!(PLLSTAT&(1<<26)));	//Wait until it is locked
	CCLKCFG   = 3;			//CClk Divider = 4 | CCLK = 72 MHz
	USBCLKCFG = 5;			//USBCLK Divide = 6 | USBCLk = 48 MHz

	PLLCON = 3;				//Set the PLL as clock source
	PLLFEED = 0xAA;
	PLLFEED = 0x55;
	
	PCLKSEL0 = 0x55515555;	//peripherals clock for all periperials = CCLK
	PCLKSEL1 = 0x15555555;
	
	MAMCR = 0x00;			//Memory accelerator module off
	MAMTIM = 0x04;			//MAM: 4cycles
	MAMCR = 0x02;			//Enable MAM
}
